'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

const CloseIcon = (props) => {
    return (React__default["default"].createElement("svg", Object.assign({ width: "24px", height: "24px", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg" }, props),
        React__default["default"].createElement("path", { d: "M6.22566 4.81096C5.83514 4.42044 5.20197 4.42044 4.81145 4.81096C4.42092 5.20148 4.42092 5.83465 4.81145 6.22517L10.5862 11.9999L4.81151 17.7746C4.42098 18.1651 4.42098 18.7983 4.81151 19.1888C5.20203 19.5793 5.8352 19.5793 6.22572 19.1888L12.0004 13.4141L17.7751 19.1888C18.1656 19.5793 18.7988 19.5793 19.1893 19.1888C19.5798 18.7983 19.5798 18.1651 19.1893 17.7746L13.4146 11.9999L19.1893 6.22517C19.5799 5.83465 19.5799 5.20148 19.1893 4.81096C18.7988 4.42044 18.1657 4.42044 17.7751 4.81096L12.0004 10.5857L6.22566 4.81096Z", fill: "black" })));
};

const ArrowLeft = (props) => {
    return (React__default["default"].createElement("svg", Object.assign({ width: "1024px", height: "1024px", viewBox: "0 0 1024 1024", xmlns: "http://www.w3.org/2000/svg" }, props),
        React__default["default"].createElement("path", { d: "M872 474H286.9l350.2-304c5.6-4.9 2.2-14-5.2-14h-88.5c-3.9 0-7.6 1.4-10.5 3.9L155 487.8a31.96 31.96 0 0 0 0 48.3L535.1 866c1.5 1.3 3.3 2 5.2 2h91.5c7.4 0 10.8-9.2 5.2-14L286.9 550H872c4.4 0 8-3.6 8-8v-60c0-4.4-3.6-8-8-8z" })));
};

const ArrowRight = (props) => {
    return (React__default["default"].createElement("svg", Object.assign({ width: "1024px", height: "1024px", viewBox: "0 0 1024 1024", xmlns: "http://www.w3.org/2000/svg" }, props),
        React__default["default"].createElement("path", { d: "M869 487.8L491.2 159.9c-2.9-2.5-6.6-3.9-10.5-3.9h-88.5c-7.4 0-10.8 9.2-5.2 14l350.2 304H152c-4.4 0-8 3.6-8 8v60c0 4.4 3.6 8 8 8h585.1L386.9 854c-5.6 4.9-2.2 14 5.2 14h91.5c1.9 0 3.8-.7 5.2-2L869 536.2a32.07 32.07 0 0 0 0-48.4z" })));
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".model {\r\n  width: 100%;\r\n  height: 100vh;\r\n  position: fixed;\r\n  top: 0;\r\n  left: 0;\r\n  display: flex;\r\n  justify-content: center;\r\n  background-color: rgb(30 32 30 / 55%);\r\n  visibility: hidden;\r\n  overflow: hidden;\r\n  z-index: 999;\r\n}\r\n\r\n.model img {\r\n  width: auto;\r\n  max-width: 100%;\r\n  height: auto;\r\n  max-height: 100%;\r\n  display: block;\r\n  line-height: 0;\r\n  box-sizing: border-box;\r\n  /* padding: 20px 0 91px; */\r\n  /* margin: 10px auto; */\r\n  margin: auto;\r\n  cursor: move;\r\n  transition: opacity 0.4s ease, visibility 0.4s ease,\r\n    transform 0.5s ease-in-out;\r\n  opacity: 0;\r\n  transform: scale(0);\r\n  user-select: none;\r\n}\r\n\r\n.model.open img {\r\n  visibility: visible;\r\n  opacity: 1;\r\n  transform: scale(1);\r\n}\r\n\r\n.model.open {\r\n  visibility: visible;\r\n}\r\n\r\n.model.open #closesvg {\r\n  position: fixed;\r\n  top: 10px;\r\n  right: 10px;\r\n  width: 2rem;\r\n  height: 2rem;\r\n  padding: 5px;\r\n  color: #fff;\r\n  cursor: pointer;\r\n}\r\n\r\n.configIcons {\r\n  position: fixed;\r\n  top: 92%;\r\n  /* right: 50%; */\r\n  padding: 5px;\r\n  display: flex;\r\n  flex-direction: row;\r\n  align-items: center;\r\n  /* gap: 15px; */\r\n}\r\n";
styleInject(css_248z);

const ImageViewer = (props) => {
    const [model, setModel] = React.useState(false);
    const [tempImgSrc, setTempImgSrc] = React.useState("");
    const imgRef = React.useRef(null);
    //get image size
    const imgSize = () => {
        const imgSepcs = document.getElementById("img_id");
        if (imgSepcs) {
            let height = imgSepcs.clientHeight;
            let width = imgSepcs.clientWidth;
            let screenHeight = window.innerHeight;
            let screenWidth = window.innerWidth;
            if (height > screenHeight || width > screenWidth) {
                height = (screenHeight * 80) / 100;
                width = (screenWidth * 80) / 100;
            }
            return { height, width };
        }
    };
    const setImgSize = () => {
        const { height, width } = imgSize();
        const modelImg = document.querySelector(".model img");
        modelImg.style.height = `${height}px`;
        modelImg.style.width = `${width}px`;
    };
    const getImg = (img) => {
        setTempImgSrc(img);
        setModel(true);
        setImgSize();
    };
    let gMouseDownX = 0;
    let gMouseDownY = 0;
    let gMouseDownOffsetX = 0;
    let gMouseDownOffsetY = 0;
    function addListeners() {
        let doc = document.getElementById("testimg");
        doc.addEventListener("mousedown", mouseDown, false);
        window.addEventListener("mouseup", mouseUp, false);
    }
    function mouseUp() {
        window.removeEventListener("mousemove", divMove, true);
    }
    function mouseDown(e) {
        gMouseDownX = e.clientX;
        gMouseDownY = e.clientY;
        let div = document.getElementById("testimg");
        //The following block gets the X offset (the difference between where it starts and where it was clicked)
        let leftPart = "";
        if (!div.style.left)
            leftPart += "0px"; //In case this was not defined as 0px explicitly.
        else
            leftPart = div.style.left;
        let leftPos = leftPart.indexOf("px");
        let leftNumString = leftPart.slice(0, leftPos); // Get the X value of the object.
        gMouseDownOffsetX = gMouseDownX - parseInt(leftNumString, 10);
        //The following block gets the Y offset (the difference between where it starts and where it was clicked)
        let topPart = "";
        if (!div.style.top)
            topPart += "0px"; //In case this was not defined as 0px explicitly.
        else
            topPart = div.style.top;
        let topPos = topPart.indexOf("px");
        let topNumString = topPart.slice(0, topPos); // Get the Y value of the object.
        gMouseDownOffsetY = gMouseDownY - parseInt(topNumString, 10);
        window.addEventListener("mousemove", divMove, true);
    }
    function divMove(e) {
        let div = document.getElementById("testimg");
        if (div) {
            div.style.position = "absolute";
            let topAmount = e.clientY - gMouseDownOffsetY;
            div.style.top = topAmount + "px";
            let leftAmount = e.clientX - gMouseDownOffsetX;
            div.style.left = leftAmount + "px";
        }
    }
    React.useEffect(() => {
        addListeners();
        return () => {
            window.removeEventListener("mousemove", divMove, true);
        };
    }, []);
    return (React__default["default"].createElement(React__default["default"].Fragment, null,
        React__default["default"].createElement("div", { className: model ? "model open" : "model" },
            React__default["default"].createElement("img", { draggable: "false", id: "testimg", ref: imgRef, src: tempImgSrc, onDragStart: (e) => e.preventDefault(), onDrag: (e) => e.preventDefault(), alt: "image" }),
            React__default["default"].createElement(CloseIcon, { id: "closesvg", width: 30, height: 30, onClick: () => setModel(false) }),
            React__default["default"].createElement("div", { className: "configIcons" },
                React__default["default"].createElement(ArrowLeft, { width: 25, height: 25 }),
                React__default["default"].createElement(ArrowRight, { width: 25, height: 25 }))),
        React__default["default"].createElement("div", { className: "images" },
            React__default["default"].createElement("img", { id: "img_id", src: props.img, height: props.height, width: props.width, alt: "image", onClick: () => getImg(props.img) }))));
};

exports.ImageViewer = ImageViewer;
//# sourceMappingURL=index.js.map
